package com.chinaitop.depot.intelligent.grainsituation.model;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class TTestdataExample {
    /**
     * t_testdata
     */
    protected String orderByClause;

    /**
     * t_testdata
     */
    protected boolean distinct;

    /**
     * t_testdata
     */
    protected List<Criteria> oredCriteria;

    public TTestdataExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    /**
     * t_testdata 2019-10-24
     */
    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("id like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("id not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andOrgIdIsNull() {
            addCriterion("org_id is null");
            return (Criteria) this;
        }

        public Criteria andOrgIdIsNotNull() {
            addCriterion("org_id is not null");
            return (Criteria) this;
        }

        public Criteria andOrgIdEqualTo(String value) {
            addCriterion("org_id =", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotEqualTo(String value) {
            addCriterion("org_id <>", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdGreaterThan(String value) {
            addCriterion("org_id >", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdGreaterThanOrEqualTo(String value) {
            addCriterion("org_id >=", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLessThan(String value) {
            addCriterion("org_id <", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLessThanOrEqualTo(String value) {
            addCriterion("org_id <=", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLike(String value) {
            addCriterion("org_id like", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotLike(String value) {
            addCriterion("org_id not like", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdIn(List<String> values) {
            addCriterion("org_id in", values, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotIn(List<String> values) {
            addCriterion("org_id not in", values, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdBetween(String value1, String value2) {
            addCriterion("org_id between", value1, value2, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotBetween(String value1, String value2) {
            addCriterion("org_id not between", value1, value2, "orgId");
            return (Criteria) this;
        }

        public Criteria andStorehouseIsNull() {
            addCriterion("storehouse is null");
            return (Criteria) this;
        }

        public Criteria andStorehouseIsNotNull() {
            addCriterion("storehouse is not null");
            return (Criteria) this;
        }

        public Criteria andStorehouseEqualTo(String value) {
            addCriterion("storehouse =", value, "storehouse");
            return (Criteria) this;
        }

        public Criteria andStorehouseNotEqualTo(String value) {
            addCriterion("storehouse <>", value, "storehouse");
            return (Criteria) this;
        }

        public Criteria andStorehouseGreaterThan(String value) {
            addCriterion("storehouse >", value, "storehouse");
            return (Criteria) this;
        }

        public Criteria andStorehouseGreaterThanOrEqualTo(String value) {
            addCriterion("storehouse >=", value, "storehouse");
            return (Criteria) this;
        }

        public Criteria andStorehouseLessThan(String value) {
            addCriterion("storehouse <", value, "storehouse");
            return (Criteria) this;
        }

        public Criteria andStorehouseLessThanOrEqualTo(String value) {
            addCriterion("storehouse <=", value, "storehouse");
            return (Criteria) this;
        }

        public Criteria andStorehouseLike(String value) {
            addCriterion("storehouse like", value, "storehouse");
            return (Criteria) this;
        }

        public Criteria andStorehouseNotLike(String value) {
            addCriterion("storehouse not like", value, "storehouse");
            return (Criteria) this;
        }

        public Criteria andStorehouseIn(List<String> values) {
            addCriterion("storehouse in", values, "storehouse");
            return (Criteria) this;
        }

        public Criteria andStorehouseNotIn(List<String> values) {
            addCriterion("storehouse not in", values, "storehouse");
            return (Criteria) this;
        }

        public Criteria andStorehouseBetween(String value1, String value2) {
            addCriterion("storehouse between", value1, value2, "storehouse");
            return (Criteria) this;
        }

        public Criteria andStorehouseNotBetween(String value1, String value2) {
            addCriterion("storehouse not between", value1, value2, "storehouse");
            return (Criteria) this;
        }

        public Criteria andHouseIsNull() {
            addCriterion("house is null");
            return (Criteria) this;
        }

        public Criteria andHouseIsNotNull() {
            addCriterion("house is not null");
            return (Criteria) this;
        }

        public Criteria andHouseEqualTo(String value) {
            addCriterion("house =", value, "house");
            return (Criteria) this;
        }

        public Criteria andHouseNotEqualTo(String value) {
            addCriterion("house <>", value, "house");
            return (Criteria) this;
        }

        public Criteria andHouseGreaterThan(String value) {
            addCriterion("house >", value, "house");
            return (Criteria) this;
        }

        public Criteria andHouseGreaterThanOrEqualTo(String value) {
            addCriterion("house >=", value, "house");
            return (Criteria) this;
        }

        public Criteria andHouseLessThan(String value) {
            addCriterion("house <", value, "house");
            return (Criteria) this;
        }

        public Criteria andHouseLessThanOrEqualTo(String value) {
            addCriterion("house <=", value, "house");
            return (Criteria) this;
        }

        public Criteria andHouseLike(String value) {
            addCriterion("house like", value, "house");
            return (Criteria) this;
        }

        public Criteria andHouseNotLike(String value) {
            addCriterion("house not like", value, "house");
            return (Criteria) this;
        }

        public Criteria andHouseIn(List<String> values) {
            addCriterion("house in", values, "house");
            return (Criteria) this;
        }

        public Criteria andHouseNotIn(List<String> values) {
            addCriterion("house not in", values, "house");
            return (Criteria) this;
        }

        public Criteria andHouseBetween(String value1, String value2) {
            addCriterion("house between", value1, value2, "house");
            return (Criteria) this;
        }

        public Criteria andHouseNotBetween(String value1, String value2) {
            addCriterion("house not between", value1, value2, "house");
            return (Criteria) this;
        }

        public Criteria andTTimeIsNull() {
            addCriterion("t_time is null");
            return (Criteria) this;
        }

        public Criteria andTTimeIsNotNull() {
            addCriterion("t_time is not null");
            return (Criteria) this;
        }

        public Criteria andTTimeEqualTo(Date value) {
            addCriterion("t_time =", value, "tTime");
            return (Criteria) this;
        }

        public Criteria andTTimeNotEqualTo(Date value) {
            addCriterion("t_time <>", value, "tTime");
            return (Criteria) this;
        }

        public Criteria andTTimeGreaterThan(Date value) {
            addCriterion("t_time >", value, "tTime");
            return (Criteria) this;
        }

        public Criteria andTTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("t_time >=", value, "tTime");
            return (Criteria) this;
        }

        public Criteria andTTimeLessThan(Date value) {
            addCriterion("t_time <", value, "tTime");
            return (Criteria) this;
        }

        public Criteria andTTimeLessThanOrEqualTo(Date value) {
            addCriterion("t_time <=", value, "tTime");
            return (Criteria) this;
        }

        public Criteria andTTimeIn(List<Date> values) {
            addCriterion("t_time in", values, "tTime");
            return (Criteria) this;
        }

        public Criteria andTTimeNotIn(List<Date> values) {
            addCriterion("t_time not in", values, "tTime");
            return (Criteria) this;
        }

        public Criteria andTTimeBetween(Date value1, Date value2) {
            addCriterion("t_time between", value1, value2, "tTime");
            return (Criteria) this;
        }

        public Criteria andTTimeNotBetween(Date value1, Date value2) {
            addCriterion("t_time not between", value1, value2, "tTime");
            return (Criteria) this;
        }

        public Criteria andIntempIsNull() {
            addCriterion("inTemp is null");
            return (Criteria) this;
        }

        public Criteria andIntempIsNotNull() {
            addCriterion("inTemp is not null");
            return (Criteria) this;
        }

        public Criteria andIntempEqualTo(BigDecimal value) {
            addCriterion("inTemp =", value, "intemp");
            return (Criteria) this;
        }

        public Criteria andIntempNotEqualTo(BigDecimal value) {
            addCriterion("inTemp <>", value, "intemp");
            return (Criteria) this;
        }

        public Criteria andIntempGreaterThan(BigDecimal value) {
            addCriterion("inTemp >", value, "intemp");
            return (Criteria) this;
        }

        public Criteria andIntempGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("inTemp >=", value, "intemp");
            return (Criteria) this;
        }

        public Criteria andIntempLessThan(BigDecimal value) {
            addCriterion("inTemp <", value, "intemp");
            return (Criteria) this;
        }

        public Criteria andIntempLessThanOrEqualTo(BigDecimal value) {
            addCriterion("inTemp <=", value, "intemp");
            return (Criteria) this;
        }

        public Criteria andIntempIn(List<BigDecimal> values) {
            addCriterion("inTemp in", values, "intemp");
            return (Criteria) this;
        }

        public Criteria andIntempNotIn(List<BigDecimal> values) {
            addCriterion("inTemp not in", values, "intemp");
            return (Criteria) this;
        }

        public Criteria andIntempBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("inTemp between", value1, value2, "intemp");
            return (Criteria) this;
        }

        public Criteria andIntempNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("inTemp not between", value1, value2, "intemp");
            return (Criteria) this;
        }

        public Criteria andInhIsNull() {
            addCriterion("inH is null");
            return (Criteria) this;
        }

        public Criteria andInhIsNotNull() {
            addCriterion("inH is not null");
            return (Criteria) this;
        }

        public Criteria andInhEqualTo(BigDecimal value) {
            addCriterion("inH =", value, "inh");
            return (Criteria) this;
        }

        public Criteria andInhNotEqualTo(BigDecimal value) {
            addCriterion("inH <>", value, "inh");
            return (Criteria) this;
        }

        public Criteria andInhGreaterThan(BigDecimal value) {
            addCriterion("inH >", value, "inh");
            return (Criteria) this;
        }

        public Criteria andInhGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("inH >=", value, "inh");
            return (Criteria) this;
        }

        public Criteria andInhLessThan(BigDecimal value) {
            addCriterion("inH <", value, "inh");
            return (Criteria) this;
        }

        public Criteria andInhLessThanOrEqualTo(BigDecimal value) {
            addCriterion("inH <=", value, "inh");
            return (Criteria) this;
        }

        public Criteria andInhIn(List<BigDecimal> values) {
            addCriterion("inH in", values, "inh");
            return (Criteria) this;
        }

        public Criteria andInhNotIn(List<BigDecimal> values) {
            addCriterion("inH not in", values, "inh");
            return (Criteria) this;
        }

        public Criteria andInhBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("inH between", value1, value2, "inh");
            return (Criteria) this;
        }

        public Criteria andInhNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("inH not between", value1, value2, "inh");
            return (Criteria) this;
        }

        public Criteria andOuttempIsNull() {
            addCriterion("outTemp is null");
            return (Criteria) this;
        }

        public Criteria andOuttempIsNotNull() {
            addCriterion("outTemp is not null");
            return (Criteria) this;
        }

        public Criteria andOuttempEqualTo(BigDecimal value) {
            addCriterion("outTemp =", value, "outtemp");
            return (Criteria) this;
        }

        public Criteria andOuttempNotEqualTo(BigDecimal value) {
            addCriterion("outTemp <>", value, "outtemp");
            return (Criteria) this;
        }

        public Criteria andOuttempGreaterThan(BigDecimal value) {
            addCriterion("outTemp >", value, "outtemp");
            return (Criteria) this;
        }

        public Criteria andOuttempGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("outTemp >=", value, "outtemp");
            return (Criteria) this;
        }

        public Criteria andOuttempLessThan(BigDecimal value) {
            addCriterion("outTemp <", value, "outtemp");
            return (Criteria) this;
        }

        public Criteria andOuttempLessThanOrEqualTo(BigDecimal value) {
            addCriterion("outTemp <=", value, "outtemp");
            return (Criteria) this;
        }

        public Criteria andOuttempIn(List<BigDecimal> values) {
            addCriterion("outTemp in", values, "outtemp");
            return (Criteria) this;
        }

        public Criteria andOuttempNotIn(List<BigDecimal> values) {
            addCriterion("outTemp not in", values, "outtemp");
            return (Criteria) this;
        }

        public Criteria andOuttempBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("outTemp between", value1, value2, "outtemp");
            return (Criteria) this;
        }

        public Criteria andOuttempNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("outTemp not between", value1, value2, "outtemp");
            return (Criteria) this;
        }

        public Criteria andOuthIsNull() {
            addCriterion("outH is null");
            return (Criteria) this;
        }

        public Criteria andOuthIsNotNull() {
            addCriterion("outH is not null");
            return (Criteria) this;
        }

        public Criteria andOuthEqualTo(BigDecimal value) {
            addCriterion("outH =", value, "outh");
            return (Criteria) this;
        }

        public Criteria andOuthNotEqualTo(BigDecimal value) {
            addCriterion("outH <>", value, "outh");
            return (Criteria) this;
        }

        public Criteria andOuthGreaterThan(BigDecimal value) {
            addCriterion("outH >", value, "outh");
            return (Criteria) this;
        }

        public Criteria andOuthGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("outH >=", value, "outh");
            return (Criteria) this;
        }

        public Criteria andOuthLessThan(BigDecimal value) {
            addCriterion("outH <", value, "outh");
            return (Criteria) this;
        }

        public Criteria andOuthLessThanOrEqualTo(BigDecimal value) {
            addCriterion("outH <=", value, "outh");
            return (Criteria) this;
        }

        public Criteria andOuthIn(List<BigDecimal> values) {
            addCriterion("outH in", values, "outh");
            return (Criteria) this;
        }

        public Criteria andOuthNotIn(List<BigDecimal> values) {
            addCriterion("outH not in", values, "outh");
            return (Criteria) this;
        }

        public Criteria andOuthBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("outH between", value1, value2, "outh");
            return (Criteria) this;
        }

        public Criteria andOuthNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("outH not between", value1, value2, "outh");
            return (Criteria) this;
        }

        public Criteria andTMaxIsNull() {
            addCriterion("t_max is null");
            return (Criteria) this;
        }

        public Criteria andTMaxIsNotNull() {
            addCriterion("t_max is not null");
            return (Criteria) this;
        }

        public Criteria andTMaxEqualTo(BigDecimal value) {
            addCriterion("t_max =", value, "tMax");
            return (Criteria) this;
        }

        public Criteria andTMaxNotEqualTo(BigDecimal value) {
            addCriterion("t_max <>", value, "tMax");
            return (Criteria) this;
        }

        public Criteria andTMaxGreaterThan(BigDecimal value) {
            addCriterion("t_max >", value, "tMax");
            return (Criteria) this;
        }

        public Criteria andTMaxGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("t_max >=", value, "tMax");
            return (Criteria) this;
        }

        public Criteria andTMaxLessThan(BigDecimal value) {
            addCriterion("t_max <", value, "tMax");
            return (Criteria) this;
        }

        public Criteria andTMaxLessThanOrEqualTo(BigDecimal value) {
            addCriterion("t_max <=", value, "tMax");
            return (Criteria) this;
        }

        public Criteria andTMaxIn(List<BigDecimal> values) {
            addCriterion("t_max in", values, "tMax");
            return (Criteria) this;
        }

        public Criteria andTMaxNotIn(List<BigDecimal> values) {
            addCriterion("t_max not in", values, "tMax");
            return (Criteria) this;
        }

        public Criteria andTMaxBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("t_max between", value1, value2, "tMax");
            return (Criteria) this;
        }

        public Criteria andTMaxNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("t_max not between", value1, value2, "tMax");
            return (Criteria) this;
        }

        public Criteria andTMinIsNull() {
            addCriterion("t_min is null");
            return (Criteria) this;
        }

        public Criteria andTMinIsNotNull() {
            addCriterion("t_min is not null");
            return (Criteria) this;
        }

        public Criteria andTMinEqualTo(BigDecimal value) {
            addCriterion("t_min =", value, "tMin");
            return (Criteria) this;
        }

        public Criteria andTMinNotEqualTo(BigDecimal value) {
            addCriterion("t_min <>", value, "tMin");
            return (Criteria) this;
        }

        public Criteria andTMinGreaterThan(BigDecimal value) {
            addCriterion("t_min >", value, "tMin");
            return (Criteria) this;
        }

        public Criteria andTMinGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("t_min >=", value, "tMin");
            return (Criteria) this;
        }

        public Criteria andTMinLessThan(BigDecimal value) {
            addCriterion("t_min <", value, "tMin");
            return (Criteria) this;
        }

        public Criteria andTMinLessThanOrEqualTo(BigDecimal value) {
            addCriterion("t_min <=", value, "tMin");
            return (Criteria) this;
        }

        public Criteria andTMinIn(List<BigDecimal> values) {
            addCriterion("t_min in", values, "tMin");
            return (Criteria) this;
        }

        public Criteria andTMinNotIn(List<BigDecimal> values) {
            addCriterion("t_min not in", values, "tMin");
            return (Criteria) this;
        }

        public Criteria andTMinBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("t_min between", value1, value2, "tMin");
            return (Criteria) this;
        }

        public Criteria andTMinNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("t_min not between", value1, value2, "tMin");
            return (Criteria) this;
        }

        public Criteria andTAvgIsNull() {
            addCriterion("t_avg is null");
            return (Criteria) this;
        }

        public Criteria andTAvgIsNotNull() {
            addCriterion("t_avg is not null");
            return (Criteria) this;
        }

        public Criteria andTAvgEqualTo(BigDecimal value) {
            addCriterion("t_avg =", value, "tAvg");
            return (Criteria) this;
        }

        public Criteria andTAvgNotEqualTo(BigDecimal value) {
            addCriterion("t_avg <>", value, "tAvg");
            return (Criteria) this;
        }

        public Criteria andTAvgGreaterThan(BigDecimal value) {
            addCriterion("t_avg >", value, "tAvg");
            return (Criteria) this;
        }

        public Criteria andTAvgGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("t_avg >=", value, "tAvg");
            return (Criteria) this;
        }

        public Criteria andTAvgLessThan(BigDecimal value) {
            addCriterion("t_avg <", value, "tAvg");
            return (Criteria) this;
        }

        public Criteria andTAvgLessThanOrEqualTo(BigDecimal value) {
            addCriterion("t_avg <=", value, "tAvg");
            return (Criteria) this;
        }

        public Criteria andTAvgIn(List<BigDecimal> values) {
            addCriterion("t_avg in", values, "tAvg");
            return (Criteria) this;
        }

        public Criteria andTAvgNotIn(List<BigDecimal> values) {
            addCriterion("t_avg not in", values, "tAvg");
            return (Criteria) this;
        }

        public Criteria andTAvgBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("t_avg between", value1, value2, "tAvg");
            return (Criteria) this;
        }

        public Criteria andTAvgNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("t_avg not between", value1, value2, "tAvg");
            return (Criteria) this;
        }

        public Criteria andDataSourceIsNull() {
            addCriterion("data_source is null");
            return (Criteria) this;
        }

        public Criteria andDataSourceIsNotNull() {
            addCriterion("data_source is not null");
            return (Criteria) this;
        }

        public Criteria andDataSourceEqualTo(String value) {
            addCriterion("data_source =", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotEqualTo(String value) {
            addCriterion("data_source <>", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceGreaterThan(String value) {
            addCriterion("data_source >", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceGreaterThanOrEqualTo(String value) {
            addCriterion("data_source >=", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceLessThan(String value) {
            addCriterion("data_source <", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceLessThanOrEqualTo(String value) {
            addCriterion("data_source <=", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceLike(String value) {
            addCriterion("data_source like", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotLike(String value) {
            addCriterion("data_source not like", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceIn(List<String> values) {
            addCriterion("data_source in", values, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotIn(List<String> values) {
            addCriterion("data_source not in", values, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceBetween(String value1, String value2) {
            addCriterion("data_source between", value1, value2, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotBetween(String value1, String value2) {
            addCriterion("data_source not between", value1, value2, "dataSource");
            return (Criteria) this;
        }

        public Criteria andIlqYqIsNull() {
            addCriterion("iLq_yq is null");
            return (Criteria) this;
        }

        public Criteria andIlqYqIsNotNull() {
            addCriterion("iLq_yq is not null");
            return (Criteria) this;
        }

        public Criteria andIlqYqEqualTo(String value) {
            addCriterion("iLq_yq =", value, "ilqYq");
            return (Criteria) this;
        }

        public Criteria andIlqYqNotEqualTo(String value) {
            addCriterion("iLq_yq <>", value, "ilqYq");
            return (Criteria) this;
        }

        public Criteria andIlqYqGreaterThan(String value) {
            addCriterion("iLq_yq >", value, "ilqYq");
            return (Criteria) this;
        }

        public Criteria andIlqYqGreaterThanOrEqualTo(String value) {
            addCriterion("iLq_yq >=", value, "ilqYq");
            return (Criteria) this;
        }

        public Criteria andIlqYqLessThan(String value) {
            addCriterion("iLq_yq <", value, "ilqYq");
            return (Criteria) this;
        }

        public Criteria andIlqYqLessThanOrEqualTo(String value) {
            addCriterion("iLq_yq <=", value, "ilqYq");
            return (Criteria) this;
        }

        public Criteria andIlqYqLike(String value) {
            addCriterion("iLq_yq like", value, "ilqYq");
            return (Criteria) this;
        }

        public Criteria andIlqYqNotLike(String value) {
            addCriterion("iLq_yq not like", value, "ilqYq");
            return (Criteria) this;
        }

        public Criteria andIlqYqIn(List<String> values) {
            addCriterion("iLq_yq in", values, "ilqYq");
            return (Criteria) this;
        }

        public Criteria andIlqYqNotIn(List<String> values) {
            addCriterion("iLq_yq not in", values, "ilqYq");
            return (Criteria) this;
        }

        public Criteria andIlqYqBetween(String value1, String value2) {
            addCriterion("iLq_yq between", value1, value2, "ilqYq");
            return (Criteria) this;
        }

        public Criteria andIlqYqNotBetween(String value1, String value2) {
            addCriterion("iLq_yq not between", value1, value2, "ilqYq");
            return (Criteria) this;
        }

        public Criteria andTPointsIsNull() {
            addCriterion("t_points is null");
            return (Criteria) this;
        }

        public Criteria andTPointsIsNotNull() {
            addCriterion("t_points is not null");
            return (Criteria) this;
        }

        public Criteria andTPointsEqualTo(String value) {
            addCriterion("t_points =", value, "tPoints");
            return (Criteria) this;
        }

        public Criteria andTPointsNotEqualTo(String value) {
            addCriterion("t_points <>", value, "tPoints");
            return (Criteria) this;
        }

        public Criteria andTPointsGreaterThan(String value) {
            addCriterion("t_points >", value, "tPoints");
            return (Criteria) this;
        }

        public Criteria andTPointsGreaterThanOrEqualTo(String value) {
            addCriterion("t_points >=", value, "tPoints");
            return (Criteria) this;
        }

        public Criteria andTPointsLessThan(String value) {
            addCriterion("t_points <", value, "tPoints");
            return (Criteria) this;
        }

        public Criteria andTPointsLessThanOrEqualTo(String value) {
            addCriterion("t_points <=", value, "tPoints");
            return (Criteria) this;
        }

        public Criteria andTPointsLike(String value) {
            addCriterion("t_points like", value, "tPoints");
            return (Criteria) this;
        }

        public Criteria andTPointsNotLike(String value) {
            addCriterion("t_points not like", value, "tPoints");
            return (Criteria) this;
        }

        public Criteria andTPointsIn(List<String> values) {
            addCriterion("t_points in", values, "tPoints");
            return (Criteria) this;
        }

        public Criteria andTPointsNotIn(List<String> values) {
            addCriterion("t_points not in", values, "tPoints");
            return (Criteria) this;
        }

        public Criteria andTPointsBetween(String value1, String value2) {
            addCriterion("t_points between", value1, value2, "tPoints");
            return (Criteria) this;
        }

        public Criteria andTPointsNotBetween(String value1, String value2) {
            addCriterion("t_points not between", value1, value2, "tPoints");
            return (Criteria) this;
        }
    }

    /**
     * t_testdata
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    /**
     * t_testdata 2019-10-24
     */
    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}